#include <SDL/SDL.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include "matr9d.h"
#include "solveur.h"

#define PI_4 0.785398

#define LARGEUR_FENETRE 900
#define HAUTEUR_FENETRE 900
/** biblihotèques :
linux
	SDLmain
	SDL
	GLU
	GL
	
compilation avec gcc:
g++ *.cpp -lSDLmain -lSDL -lGLU -lGL
	
windows
	mingw32
	SDLmain
	SDL
	opengl32
	glu32
**/

int continuer();

int iteration = 0;

int main(int argc, char *argv[])
{

    SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);
    SDL_WM_SetCaption("Equilibretot", NULL);

    SDL_SetVideoMode(LARGEUR_FENETRE, HAUTEUR_FENETRE, 32, SDL_OPENGL);


    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective(50,(double)LARGEUR_FENETRE/HAUTEUR_FENETRE,1,1000);
    glEnable(GL_DEPTH_TEST);

    double coef=1;


    Solveur b(70);
    b.accelere_rot(coef*Vect3d(0,1,1));
    b.corrigevars();
    b.recentre();
    b.barycentretot = Vect3d(0,0,0);

    b.corrige();



    double E0 = b.getenergie();




    Uint32 temps = SDL_GetTicks()-50;
    Uint32 tempspasse;

    // program main loop
    while (continuer())
    {
        glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
        glMatrixMode( GL_MODELVIEW );
        glLoadIdentity();
        gluLookAt(0,0,4,0,0,0,0,1,0);
        glPushMatrix();


        glColor3ub(255,255,0);
        b.affiche();

        /* pour afficher les forces
        glColor3ub(0,255,0);
        glPushMatrix();
        glTranslated(b.barycentretot.x,b.barycentretot.y,b.barycentretot.z);
        glBegin(GL_LINES);
        int l;
        for(l=0;l<b.listejoints.end();l++){
            Vect3d const &v1= (*b.listejoints(l)).A();
            Vect3d v2 = 0.04*b.constante(l) +v1;
            glVertex3dv((GLdouble*)&v1);
            glVertex3dv((GLdouble*)&v2);
            //v1.print("vecteur");
            //(v1-v2).print("vecteur2");
        }
        glEnd();
        glPopMatrix();

        //*/


        b.corrigepos();
        b.corrigev();
        b.incrementeforce4(PAS_TEMPS);
        b.impulsion();

        //b.inversedyn();
        //b.constante.print("test");

        iteration++;


        glPopMatrix();
        glFlush();
        SDL_GL_SwapBuffers();

        tempspasse = temps - SDL_GetTicks() + DELAY_FRAME;
        if (tempspasse < 10000)SDL_Delay(tempspasse);
        temps = SDL_GetTicks();

    } // end main loop



    double Ef = b.getenergie();
    printf("erreur d'energie après %d iterations : %e \n",iteration, (Ef-E0)/E0);

    // all is well ;)
    printf("Exited cleanly\n");
    return 0;
}

int continuer(){

    SDL_Event event;
    int c=1;
    while (SDL_PollEvent(&event)){
    switch (event.type)
        {
        case SDL_QUIT:
            c = 0;break;
        case SDL_KEYDOWN: /* Si appui d'une touche */
            switch (event.key.keysym.sym)
                {
                case SDLK_ESCAPE: /* Appui sur la touche Echap, on arrête le programme */
                    c = 0;break;
                default: ;
                }
            break;
        default: ;
        }
    }
    return c;
}

