#ifndef PARTIE_CORPS_H
#define PARTIE_CORPS_H

#include "matr9d.h"
#include "joint.h"
#include "patrons.h"


class Solide{
    public:
    Solide(double m,Vect3d const& dimensions);
    inline Matr9d getinertie()const {return R*inertie0*transpo(R);}

    inline Vect3d A()const{if(liens.end()>0){return (*liens(0)).A();} else return p;}

    /** caractéristiques constantes **/
    double masse;
    Matr9d inertie0;
    dynamictab<Joint*> liens;
    int numero; // numéro du solide

    /** caractéristiques variables **/
    // termes pour stocker l'itération actuelle ou pour calculer les accélérations
    Quaternion q;// passage de la base terrestre à la base locale
    Matr9d R;// passage de la base terrestre à la base locale
    Vect3d w;// dans la base terrestre, vitesse de rotation
    Vect3d p;// dans la base terrestre, position du barycentre
    Vect3d v;// dans la base terrestre, vitesse du barycentre

    // tèrmes pour stocker les accélérations
    Vect3d acceleration;// dans la base terrestre, accéleration du barycentre
    Vect3d a_rot;// dans la base terrestre, accéleration en rotation

    // tèrmes pour stocker l'itération précédente
    Quaternion q0;
    Vect3d w0;
    Vect3d p0;
    Vect3d v0;

    // tèrmes pour stocker la somme (k1 + 2*k2 + 2*k3 + k4)
    Quaternion q1;
    Vect3d w1;
    Vect3d p1;
    Vect3d v1;
};





#endif
